Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -5219,110 +6339,128 @@
             di->key.obj_type = TYPE_ROOT_ITEM;
             di->key.offset = 0xffffffffffffffff;
         }
-        
+
         di->transid = fileref->fcb->Vcb->superblock.generation;
         di->m = 0;
-        di->n = (UINT16)fileref->utf8.Length;
+        di->n = (UINT16)fileref->dc->utf8.Length;
         di->type = fileref->fcb->type;
-        RtlCopyMemory(di->name, fileref->utf8.Buffer, fileref->utf8.Length);
-        
+        RtlCopyMemory(di->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+
         RtlCopyMemory(di2, di, disize);
-        
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
-                                    di, disize, Batch_DirItem, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
+                                        di, disize, Batch_DirItem);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            ExFreePool(di2);
+            ExFreePool(di);
+            return Status;
         }
-        
+
         if (fileref->parent->fcb->subvol == fileref->fcb->subvol) {
             INODE_REF *ir, *ir2;
-            
+
             // delete INODE_REF (0xc)
-            
+
             ir = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + oldutf8->Length, ALLOC_TAG);
             if (!ir) {
                 ERR("out of memory\n");
+                ExFreePool(di2);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
 
-            ir->index = fileref->index;
+            ir->index = fileref->dc->index;
             ir->n = oldutf8->Length;
             RtlCopyMemory(ir->name, oldutf8->Buffer, ir->n);
-        
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
-                                        ir, sizeof(INODE_REF) - 1 + ir->n, Batch_DeleteInodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
+                                            ir, sizeof(INODE_REF) - 1 + ir->n, Batch_DeleteInodeRef);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                ExFreePool(ir);
+                ExFreePool(di2);
+                return Status;
             }
-            
+
             // add INODE_REF (0xc)
-            
-            ir2 = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->utf8.Length, ALLOC_TAG);
+
+            ir2 = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->dc->utf8.Length, ALLOC_TAG);
             if (!ir2) {
                 ERR("out of memory\n");
+                ExFreePool(di2);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
 
-            ir2->index = fileref->index;
-            ir2->n = fileref->utf8.Length;
-            RtlCopyMemory(ir2->name, fileref->utf8.Buffer, ir2->n);
-        
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
-                                        ir2, sizeof(INODE_REF) - 1 + ir2->n, Batch_InodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+            ir2->index = fileref->dc->index;
+            ir2->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(ir2->name, fileref->dc->utf8.Buffer, ir2->n);
+
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
+                                            ir2, sizeof(INODE_REF) - 1 + ir2->n, Batch_InodeRef);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                ExFreePool(ir2);
+                ExFreePool(di2);
+                return Status;
             }
-        } else { // subvolume
+        } else if (fileref->fcb != fileref->fcb->Vcb->dummy_fcb) { // subvolume
             ULONG rrlen;
             ROOT_REF* rr;
-            
-            // FIXME - make sure this works with duff subvols within snapshots
-            
-            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, oldutf8, Irp, rollback);
+
+            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, oldutf8, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("delete_root_ref returned %08x\n", Status);
+                ExFreePool(di2);
+                return Status;
             }
-            
-            rrlen = sizeof(ROOT_REF) - 1 + fileref->utf8.Length;
-            
+
+            rrlen = sizeof(ROOT_REF) - 1 + fileref->dc->utf8.Length;
+
             rr = ExAllocatePoolWithTag(PagedPool, rrlen, ALLOC_TAG);
             if (!rr) {
                 ERR("out of memory\n");
+                ExFreePool(di2);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             rr->dir = fileref->parent->fcb->inode;
-            rr->index = fileref->index;
-            rr->n = fileref->utf8.Length;
-            RtlCopyMemory(rr->name, fileref->utf8.Buffer, fileref->utf8.Length);
-            
-            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp, rollback);
+            rr->index = fileref->dc->index;
+            rr->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(rr->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+
+            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("add_root_ref returned %08x\n", Status);
+                ExFreePool(di2);
                 return Status;
             }
-            
-            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp, rollback);
+
+            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("update_root_backref returned %08x\n", Status);
+                ExFreePool(di2);
                 return Status;
             }
         }
-        
+
         // delete DIR_INDEX (0x60)
-        
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
-                                    fileref->index, NULL, 0, Batch_Delete, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                        fileref->dc->index, NULL, 0, Batch_Delete);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            ExFreePool(di2);
+            return Status;
         }
-        
+
         // add DIR_INDEX (0x60)
-        
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
-                                    fileref->index, di2, disize, Batch_Insert, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+
+       Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                       fileref->dc->index, di2, disize, Batch_Insert);
+       if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            ExFreePool(di2);
+            return Status;
         }
 
         if (fileref->oldutf8.Buffer) {
@@ -5332,14 +6470,419 @@
     }
 
     fileref->dirty = FALSE;
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS STDCALL do_write(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+static void flush_disk_caches(device_extension* Vcb) {
+    LIST_ENTRY* le;
+    ioctl_context context;
+    ULONG num;
+
+    context.left = 0;
+
+    le = Vcb->devices.Flink;
+
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+        if (dev->devobj && !dev->readonly && dev->can_flush)
+            context.left++;
+
+        le = le->Flink;
+    }
+
+    if (context.left == 0)
+        return;
+
+    num = 0;
+
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+
+    context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(ioctl_context_stripe) * context.left, ALLOC_TAG);
+    if (!context.stripes) {
+        ERR("out of memory\n");
+        return;
+    }
+
+    RtlZeroMemory(context.stripes, sizeof(ioctl_context_stripe) * context.left);
+
+    le = Vcb->devices.Flink;
+
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+        if (dev->devobj && !dev->readonly && dev->can_flush) {
+            PIO_STACK_LOCATION IrpSp;
+            ioctl_context_stripe* stripe = &context.stripes[num];
+
+            RtlZeroMemory(&stripe->apte, sizeof(ATA_PASS_THROUGH_EX));
+
+            stripe->apte.Length = sizeof(ATA_PASS_THROUGH_EX);
+            stripe->apte.TimeOutValue = 5;
+            stripe->apte.CurrentTaskFile[6] = IDE_COMMAND_FLUSH_CACHE;
+
+            stripe->Irp = IoAllocateIrp(dev->devobj->StackSize, FALSE);
+
+            if (!stripe->Irp) {
+                ERR("IoAllocateIrp failed\n");
+                goto nextdev;
+            }
+
+            IrpSp = IoGetNextIrpStackLocation(stripe->Irp);
+            IrpSp->MajorFunction = IRP_MJ_DEVICE_CONTROL;
+
+            IrpSp->Parameters.DeviceIoControl.IoControlCode = IOCTL_ATA_PASS_THROUGH;
+            IrpSp->Parameters.DeviceIoControl.InputBufferLength = sizeof(ATA_PASS_THROUGH_EX);
+            IrpSp->Parameters.DeviceIoControl.OutputBufferLength = sizeof(ATA_PASS_THROUGH_EX);
+
+            stripe->Irp->AssociatedIrp.SystemBuffer = &stripe->apte;
+            stripe->Irp->Flags |= IRP_BUFFERED_IO | IRP_INPUT_OPERATION;
+            stripe->Irp->UserBuffer = &stripe->apte;
+            stripe->Irp->UserIosb = &stripe->iosb;
+
+            IoSetCompletionRoutine(stripe->Irp, ioctl_completion, &context, TRUE, TRUE, TRUE);
+
+            IoCallDriver(dev->devobj, stripe->Irp);
+
+nextdev:
+            num++;
+        }
+
+        le = le->Flink;
+    }
+
+    KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+
+    ExFreePool(context.stripes);
+}
+
+static NTSTATUS flush_changed_dev_stats(device_extension* Vcb, device* dev, PIRP Irp) {
     NTSTATUS Status;
+    KEY searchkey;
+    traverse_ptr tp;
+    UINT16 statslen;
+    UINT64* stats;
+
+    searchkey.obj_id = 0;
+    searchkey.obj_type = TYPE_DEV_STATS;
+    searchkey.offset = dev->devitem.dev_id;
+
+    Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return Status;
+    }
+
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
+
+    statslen = sizeof(UINT64) * 5;
+    stats = ExAllocatePoolWithTag(PagedPool, statslen, ALLOC_TAG);
+    if (!stats) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    RtlCopyMemory(stats, dev->stats, statslen);
+
+    Status = insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, dev->devitem.dev_id, stats, statslen, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(stats);
+        return Status;
+    }
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS flush_subvol(device_extension* Vcb, root* r, PIRP Irp) {
+    NTSTATUS Status;
+
+    if (r != Vcb->root_root && r != Vcb->chunk_root) {
+        KEY searchkey;
+        traverse_ptr tp;
+        ROOT_ITEM* ri;
+
+        searchkey.obj_id = r->id;
+        searchkey.obj_type = TYPE_ROOT_ITEM;
+        searchkey.offset = 0xffffffffffffffff;
+
+        Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("error - find_item returned %08x\n", Status);
+            return Status;
+        }
+
+        if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
+            ERR("could not find ROOT_ITEM for tree %llx\n", searchkey.obj_id);
+            return STATUS_INTERNAL_ERROR;
+        }
+
+        ri = ExAllocatePoolWithTag(PagedPool, sizeof(ROOT_ITEM), ALLOC_TAG);
+        if (!ri) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        RtlCopyMemory(ri, &r->root_item, sizeof(ROOT_ITEM));
+
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
+        Status = insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
+
+    if (r->received) {
+        KEY searchkey;
+        traverse_ptr tp;
+
+        if (!Vcb->uuid_root) {
+            root* uuid_root;
+
+            TRACE("uuid root doesn't exist, creating it\n");
+
+            Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("create_root returned %08x\n", Status);
+                return Status;
+            }
+
+            Vcb->uuid_root = uuid_root;
+        }
+
+        RtlCopyMemory(&searchkey.obj_id, &r->root_item.received_uuid, sizeof(UINT64));
+        searchkey.obj_type = TYPE_SUBVOL_REC_UUID;
+        RtlCopyMemory(&searchkey.offset, &r->root_item.received_uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
+
+        Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("find_item returned %08x\n", Status);
+            return Status;
+        }
+
+        if (!keycmp(tp.item->key, searchkey)) {
+            if (tp.item->size + sizeof(UINT64) <= Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node)) {
+                UINT64* ids;
+
+                ids = ExAllocatePoolWithTag(PagedPool, tp.item->size + sizeof(UINT64), ALLOC_TAG);
+                if (!ids) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+
+                RtlCopyMemory(ids, tp.item->data, tp.item->size);
+                RtlCopyMemory((UINT8*)ids + tp.item->size, &r->id, sizeof(UINT64));
+
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    ExFreePool(ids);
+                    return Status;
+                }
+
+                Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, ids, tp.item->size + sizeof(UINT64), NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    ExFreePool(ids);
+                    return Status;
+                }
+            }
+        } else {
+            UINT64* root_num;
+
+            root_num = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64), ALLOC_TAG);
+            if (!root_num) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
+            *root_num = r->id;
+
+            Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                ExFreePool(root_num);
+                return Status;
+            }
+        }
+
+        r->received = FALSE;
+    }
+
+    r->dirty = FALSE;
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS test_not_full(device_extension* Vcb) {
+    UINT64 reserve, could_alloc, free_space;
+    LIST_ENTRY* le;
+
+    // This function ensures we drop into readonly mode if we're about to leave very little
+    // space for metadata - this is similar to the "global reserve" of the Linux driver.
+    // Otherwise we might completely fill our space, at which point due to COW we can't
+    // delete anything in order to fix this.
+
+    reserve = Vcb->extent_root->root_item.bytes_used;
+    reserve += Vcb->root_root->root_item.bytes_used;
+    if (Vcb->checksum_root) reserve += Vcb->checksum_root->root_item.bytes_used;
+
+    reserve = max(reserve, 0x1000000); // 16 M
+    reserve = min(reserve, 0x20000000); // 512 M
+
+    // Find out how much space would be available for new metadata chunks
+
+    could_alloc = 0;
+
+    if (Vcb->metadata_flags & BLOCK_FLAG_RAID5) {
+        UINT64 s1 = 0, s2 = 0, s3 = 0;
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (!dev->readonly) {
+                UINT64 space = dev->devitem.num_bytes - dev->devitem.bytes_used;
+
+                if (space >= s1) {
+                    s3 = s2;
+                    s2 = s1;
+                    s1 = space;
+                } else if (space >= s2) {
+                    s3 = s2;
+                    s2 = space;
+                } else if (space >= s3)
+                    s3 = space;
+            }
+
+            le = le->Flink;
+        }
+
+        could_alloc = s3 * 2;
+    } else if (Vcb->metadata_flags & (BLOCK_FLAG_RAID10 | BLOCK_FLAG_RAID6)) {
+        UINT64 s1 = 0, s2 = 0, s3 = 0, s4 = 0;
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (!dev->readonly) {
+                UINT64 space = dev->devitem.num_bytes - dev->devitem.bytes_used;
+
+                if (space >= s1) {
+                    s4 = s3;
+                    s3 = s2;
+                    s2 = s1;
+                    s1 = space;
+                } else if (space >= s2) {
+                    s4 = s3;
+                    s3 = s2;
+                    s2 = space;
+                } else if (space >= s3) {
+                    s4 = s3;
+                    s3 = space;
+                } else if (space >= s4)
+                    s4 = space;
+            }
+
+            le = le->Flink;
+        }
+
+        could_alloc = s4 * 2;
+    } else if (Vcb->metadata_flags & (BLOCK_FLAG_RAID0 | BLOCK_FLAG_RAID1)) {
+        UINT64 s1 = 0, s2 = 0;
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (!dev->readonly) {
+                UINT64 space = dev->devitem.num_bytes - dev->devitem.bytes_used;
+
+                if (space >= s1) {
+                    s2 = s1;
+                    s1 = space;
+                } else if (space >= s2)
+                    s2 = space;
+            }
+
+            le = le->Flink;
+        }
+
+        if (Vcb->metadata_flags & BLOCK_FLAG_RAID1)
+            could_alloc = s2;
+        else // RAID0
+            could_alloc = s2 * 2;
+    } else if (Vcb->metadata_flags & BLOCK_FLAG_DUPLICATE) {
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (!dev->readonly) {
+                UINT64 space = (dev->devitem.num_bytes - dev->devitem.bytes_used) / 2;
+
+                could_alloc = max(could_alloc, space);
+            }
+
+            le = le->Flink;
+        }
+    } else { // SINGLE
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (!dev->readonly) {
+                UINT64 space = dev->devitem.num_bytes - dev->devitem.bytes_used;
+
+                could_alloc = max(could_alloc, space);
+            }
+
+            le = le->Flink;
+        }
+    }
+
+    if (could_alloc >= reserve)
+        return STATUS_SUCCESS;
+
+    free_space = 0;
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (!c->reloc && !c->readonly && c->chunk_item->type & BLOCK_FLAG_METADATA) {
+            free_space += c->chunk_item->size - c->used;
+
+            if (free_space + could_alloc >= reserve)
+                return STATUS_SUCCESS;
+        }
+
+        le = le->Flink;
+    }
+
+    return STATUS_DISK_FULL;
+}
+
+static NTSTATUS do_write2(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     LIST_ENTRY *le, batchlist;
     BOOL cache_changed = FALSE;
+    volume_device_extension* vde;
+    BOOL no_cache = FALSE;
 #ifdef DEBUG_FLUSH_TIMES
     UINT64 filerefs = 0, fcbs = 0;
     LARGE_INTEGER freq, time1, time2;
@@ -5347,33 +6890,36 @@
 #ifdef DEBUG_WRITE_LOOPS
     UINT loops = 0;
 #endif
-    
+
     TRACE("(%p)\n", Vcb);
-    
+
     InitializeListHead(&batchlist);
 
 #ifdef DEBUG_FLUSH_TIMES
     time1 = KeQueryPerformanceCounter(&freq);
 #endif
-    
+
+    ExAcquireResourceExclusiveLite(&Vcb->dirty_filerefs_lock, TRUE);
+
     while (!IsListEmpty(&Vcb->dirty_filerefs)) {
-        dirty_fileref* dirt;
-        
-        le = RemoveHeadList(&Vcb->dirty_filerefs);
-        
-        dirt = CONTAINING_RECORD(le, dirty_fileref, list_entry);
-        
-        flush_fileref(dirt->fileref, &batchlist, Irp, rollback);
-        free_fileref(dirt->fileref);
-        ExFreePool(dirt);
+        file_ref* fr = CONTAINING_RECORD(RemoveHeadList(&Vcb->dirty_filerefs), file_ref, list_entry_dirty);
 
+        flush_fileref(fr, &batchlist, Irp);
+        free_fileref(Vcb, fr);
+
 #ifdef DEBUG_FLUSH_TIMES
         filerefs++;
 #endif
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
-    
+
+    ExReleaseResourceLite(&Vcb->dirty_filerefs_lock);
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        return Status;
+    }
+
 #ifdef DEBUG_FLUSH_TIMES
     time2 = KeQueryPerformanceCounter(NULL);
 
@@ -5384,58 +6930,78 @@
 
     // We process deleted streams first, so we don't run over our xattr
     // limit unless we absolutely have to.
-    
+    // We also process deleted normal files, to avoid any problems
+    // caused by inode collisions.
+
+    ExAcquireResourceExclusiveLite(&Vcb->dirty_fcbs_lock, TRUE);
+
     le = Vcb->dirty_fcbs.Flink;
     while (le != &Vcb->dirty_fcbs) {
-        dirty_fcb* dirt;
+        fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry_dirty);
         LIST_ENTRY* le2 = le->Flink;
-        
-        dirt = CONTAINING_RECORD(le, dirty_fcb, list_entry);
-        
-        if (dirt->fcb->deleted && dirt->fcb->ads) {
-            RemoveEntryList(le);
-            
-            ExAcquireResourceExclusiveLite(dirt->fcb->Header.Resource, TRUE);
-            flush_fcb(dirt->fcb, FALSE, &batchlist, Irp, rollback);
-            ExReleaseResourceLite(dirt->fcb->Header.Resource);
-            
-            free_fcb(dirt->fcb);
-            ExFreePool(dirt);
 
+        if (fcb->deleted) {
+            ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+            Status = flush_fcb(fcb, FALSE, &batchlist, Irp);
+            ExReleaseResourceLite(fcb->Header.Resource);
+
+            free_fcb(Vcb, fcb);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("flush_fcb returned %08x\n", Status);
+                clear_batch_list(Vcb, &batchlist);
+                ExReleaseResourceLite(&Vcb->dirty_fcbs_lock);
+                return Status;
+            }
+
 #ifdef DEBUG_FLUSH_TIMES
             fcbs++;
 #endif
         }
-        
+
         le = le2;
     }
-    
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->dirty_fcbs_lock);
+        return Status;
+    }
+
     le = Vcb->dirty_fcbs.Flink;
     while (le != &Vcb->dirty_fcbs) {
-        dirty_fcb* dirt;
+        fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry_dirty);
         LIST_ENTRY* le2 = le->Flink;
-        
-        dirt = CONTAINING_RECORD(le, dirty_fcb, list_entry);
-        
-        if (dirt->fcb->subvol != Vcb->root_root || dirt->fcb->deleted) {
-            RemoveEntryList(le);
-            
-            ExAcquireResourceExclusiveLite(dirt->fcb->Header.Resource, TRUE);
-            flush_fcb(dirt->fcb, FALSE, &batchlist, Irp, rollback);
-            ExReleaseResourceLite(dirt->fcb->Header.Resource);
-            free_fcb(dirt->fcb);
-            ExFreePool(dirt);
 
+        if (fcb->subvol != Vcb->root_root) {
+            ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+            Status = flush_fcb(fcb, FALSE, &batchlist, Irp);
+            ExReleaseResourceLite(fcb->Header.Resource);
+            free_fcb(Vcb, fcb);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("flush_fcb returned %08x\n", Status);
+                ExReleaseResourceLite(&Vcb->dirty_fcbs_lock);
+                return Status;
+            }
+
 #ifdef DEBUG_FLUSH_TIMES
             fcbs++;
 #endif
         }
-        
+
         le = le2;
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
-    
+
+    ExReleaseResourceLite(&Vcb->dirty_fcbs_lock);
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        return Status;
+    }
+
 #ifdef DEBUG_FLUSH_TIMES
     time2 = KeQueryPerformanceCounter(NULL);
 
